#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#
# alone : web application framework for small embedded systems.
#               Copyright (c) 2009-2010 Inas Co Ltd. All Rights Reserved.
#
# This file is destributed under BSD License. Please read the COPYRIGHT file.
#

require 'al_form'
require 'al_persist'
require 'al_mif'

DB_FILE = "data/todo.db"


class AlController

  ##
  # constructor
  #
  def initialize()
    @form = AlForm.new( [
      AlInteger.new( "id", :foreign=>true ),
      AlDate.new( "create_date", :label=>"登録日", :value=>Time.now.strftime( '%Y/%m/%d' ) ),
      AlTextArea.new( "memo", :label=>"ToDoメモ", :required=>true ),
      AlDate.new( "limit_date", :label=>"期限" ),
      AlSubmit.new( "submit1", :value=>"決定",
        :tag_attr=> {:style=>"float: right;"} )
    ] )

    # use sqlite3
    @persist = AlPersist.sqlite( DB_FILE ).table( "todo", :id )

  end


  ##
  # デフォルトアクション
  #
  def action_index
    begin
      action_list
      
    rescue =>ex
      if ex.message =~ /^no such table/
        AlPersist.sqlite( DB_FILE ).run( "create table todo ( id integer primary key autoincrement, create_date timestamp, memo text, limit_date timestamp );" )
        retry
      else
        raise ex
      end
    end
  end

end
