#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
# alone : web application framework for small embedded systems.
#               Copyright (c) 2009-2010 Inas Co Ltd. All Rights Reserved.
#
# This file is destributed under BSD License. Please read the COPYRIGHT file.
#
#@brief
# テンプレートエンジン ERB利用
#

require 'erb'
include ERB::Util


def header_section()
  return AL_TEMPLATE_HEADER
end


def body_section()
  return AL_TEMPLATE_BODY
end


def footer_section()
  return AL_TEMPLATE_FOOTER
end


##
# ERB テンプレートラッパー
#
class AlTemplate

  ##
  # テンプレートファイルを適用し、レンダリングし、表示する。
  #
  #@param  [String]  filename   ファイル名
  #@param  [Binding] b          binding
  #
  def self.run( filename, b = nil )
    if filename[0] == '/'
      file = filename
    else
      file = "#{AL_TEMPLATE_DIR}/#{filename}"
    end
    template = ERB.new( File.read( file ), nil, '%' )

    begin
      if b
        template.run( b )
        
      elsif defined?( $AlController )
        $AlController.instance_eval() do
          template.run( binding )
        end

      else
        template.run()
      end

    rescue => ex
      raise ex, "Error in template. #{ex.message}"
    end
  end

end
