#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
# alone : web application framework for small embedded systems.
#               Copyright (c) 2009-2010 Inas Co Ltd. All Rights Reserved.
#
# This file is destributed under BSD License. Please read the COPYRIGHT file.
#
# フォームマネージャ ファイルアップロードウィジェット
#


##
# ファイルウィジェット
#
class AlFile < AlWidget

  ##
  # (AlFile) バリデート
  #
  #@return [Boolean]            成否
  #
  def validate()
    @message = ""
    if @value.class != Hash
      raise "AlFile needs \@value by hash obj. #{@value.class} given, now.  Maybe enctype is not multipart/form-data."
    end

    if @value[:size] == 0
      if @required
        @message = "#{@label}を指定してください。"
        return false
      end
    end

    return true
  end


  ##
  # (AlFile) HTMLタグの生成
  #
  #@param [Hash] arg            htmlタグへ追加するアトリビュートを指定
  #@return [String]             htmlタグ
  #@note
  # hiddenフラグは未対応。type="file"は動作が特殊なので、hiddenにする意味がない。
  #
  def make_tag( arg = {} )
    r = %Q(<input type="file" name="#{@name}" )
    (@tag_attr.merge arg).each do |k,v|
      r << %Q( #{k}="#{Alone::escape_html(v)}")
    end
    return "#{r} #{AL_FORM_EMPTYTAG_CLOSE}"
  end

end
